<?php

use \WOO_PRODUCT_TABLE_PRO\Classes\Design_Tab_Generate;

$f_args = [
    'table_header' => [
        'title' => __('Table Header', 'wpt_pro'),
        'item' => [
            [
                'title' => __('Background-Color', 'wpt_pro'),
                'selector' => 'tr.wpt_table_head th',
                'property' => 'background-color',
                'type' => 'color',
            ],
            
            [
                'title' => __('Border-Color', 'wpt_pro'),
                'selector' => 'table thead',
                'property' => 'border-color',
                'type' => 'color',
            ],
            [
                'title' => __('Text-Color', 'wpt_pro'),
                'selector' => 'tr.wpt_table_head th',
                'property' => 'color',
                'type' => 'color',
            ],
            [
                'title' => __('Border Width', 'wpt_pro'),
                'selector' => 'table thead',
                'property' => 'border-width',
                'type' => 'text',
                'placeholder' => 'eg: 1px solid black',
            ],
            [
                'title' => __('Padding', 'wpt_pro'),
                'selector' => 'tr.wpt_table_head th',
                'property' => 'padding',
                'type' => 'text',
                'placeholder' => 'eg: 10px',
            ],
            [
                'title' => __('Text Alignment', 'wpt_pro'),
                'selector' => 'tr.wpt_table_head th',
                'property' => 'text-align',
                'type' => 'select',
                'options' => [
                    '' => 'Blank (Default)',
                    'initial' => 'Initial',
                    'center' => 'Center',
                    'left' => 'Left',
                    'right' => 'Right',
                ],
            ],
            [
                'title' => __('Sorted Column BG', 'wpt_pro'),
                'selector' => 'tr th.this_column_sorted',
                'property' => 'background-color',
                'type' => 'color',
            ],
            [
                'title' => __( 'Font Size', 'wpt_pro'),
                'selector' => 'tr th',
                'property' => 'font-size',
                'type' => 'text',
                'placeholder' => 'eg: 10px',
            ],
            [
                'title' => __( 'Font Weight', 'wpt_pro'),
                'selector' => 'tr th',
                'property' => 'font-weight',
                'type' => 'text',
                'placeholder' => 'eg: bold',
            ],
            [
                'title' => __('Column Label in Auto Responsive', 'wpt_pro'),
                'selector' => 'tr.wpt_table_head th',
                'property' => 'auto-responsive-column-label',
                'type' => 'select',
                'options' => [
                    'show' => 'Show',
                    'hide' => 'Hide',
                
                ],
                'desc' => 'Show or hide table column label in mobile or tablet device only when there is no column selected for tablet or mobile device.',
            ],

        ],
    ],
        
    'body'  =>[
        'title' => 'Table Body',
        'item'  => [
            [
                'title' => __('Background Color', 'wpt_pro'),
                'selector' => 'tbody tr td',
                'property' => 'background-color',
                'value'    => '',
                'type'=>'color'
            ],
            [
                'title' => __('Background Row Hover Color', 'wpt_pro'),
                'selector' => 'tbody tr:hover td',
                'property' => 'background-color',
                'value'    => '',
                'type'=>'color'
            ],
            [
                'title' => __('Border Color', 'wpt_pro'),
                'selector' => 'tbody tr td',
                'property' => 'border-color',
                'value'    => '',
                'type'=>'color'
            ],
            [
                'title' => __( 'Text Color', 'wpt_pro'),
                'selector' => 'tbody tr td',
                'property' => 'color',
                'value'    => '',
                'type'=>'color'
            ],
            [
                'title' => __( 'Link Color', 'wpt_pro'),
                'selector' => 'tbody tr td a',
                'property' => 'color',
                'value'    => '',
                'type'=>'color'
            ],
            [
                'title' => __( 'Link Hover Color', 'wpt_pro'),
                'selector' => 'tbody tr td a:hover',
                'property' => 'color',
                'value'    => '',
                'type'=>'color'
            ],
            [
                'title' => __( 'TD Padding', 'wpt_pro'),
                'selector' => 'tbody tr td',
                'property' => 'padding',
                'value'    => '',
                'type'=>'text',
                'placeholder' => 'eg: 5px',
            ],
            [
                'title' => __( 'Sorted Column BG', 'wpt_pro'),
                'selector' => 'tbody tr td.this_column_sorted',
                'property' => 'background-color',
                'value'    => '',
                'type'=>'color'
            ],
            [
                'title' => __( 'Font Size', 'wpt_pro'),
                'selector' => 'tbody tr td div',
                'property' => 'font-size',
                'value'    => '',
                'type'=>'text',
                'placeholder' => 'eg: 17px',
            ],
            [
                'title' => __( 'Font Weight', 'wpt_pro'),
                'selector' => 'tbody tr td div',
                'property' => 'font-weight',
                'value'    => '',
                'type'=>'text',
                'placeholder' => 'eg: bold',
            ],

            
            

        ]
    ],
    'checkbox'  =>[
        'title' => 'Checkbox Style',
        'item'  => [
            [
                'title' => __('Checkbox Background Color', 'wpt_pro'),
                'selector' => 'input{type=checkbox}:checked%label:before',
                'property' => 'background-color',
                'value'    => '',
                'type'=>'color'
            ],
            [
                'title' => __('Checkbox Border Color', 'wpt_pro'),
                'selector' => 'input{type=checkbox}:checked%label:before',
                'property' => 'border-color',
                'value'    => '',
                'type'=>'color'
            ],
            [
                'title' => __('Checkbox Color', 'wpt_pro'),
                'selector' => 'input{type=checkbox}:checked%label:after',
                'property' => 'color',
                'value'    => '',
                'type'=>'color'
            ],
        ]
    ],
    'button_style'  =>[
        'title' => 'Button Style',
        'item'  => [
            [
                'title' => __('Background Color', 'wpt_pro'),
                'selector' => '.button',
                'property' => 'background-color',
                'value'    => '',
                'type'=>'color'
            ],
            [
                'title' => __('Hover Background Color', 'wpt_pro'),
                'selector' => '.button:hover',
                'property' => 'background-color',
                'value'    => '',
                'type'=>'color'
            ],
            [
                'title' => __('Text Color', 'wpt_pro'),
                'selector' => '.button',
                'property' => 'color',
                'value'    => '',
                'type'=>'color'
            ],
            [
                'title' => __('Text Hover Color', 'wpt_pro'),
                'selector' => '.button:hover',
                'property' => 'color',
                'value'    => '',
                'type'=>'color'
            ],
            [
                'title' => __('Background Color', 'wpt_pro'),
                'selector' => '.button',
                'property' => 'background-color',
                'value'    => '',
                'type'=>'color'
            ],
        ]
    ],
    'add_to_cart'  =>[
        'title' => 'Add to cart Button',
        'item'  => [
            [
                'title' => __('Background Color', 'wpt_pro'),
                'selector' => 'a.wpt_woo_add_cart_button',
                'property' => 'background-color',
                'value'    => '',
                'type'=>'color'
            ],
            [
                'title' => __('Hover Background Color', 'wpt_pro'),
                'selector' => 'a.wpt_woo_add_cart_button:hover',
                'property' => 'background-color',
                'value'    => '',
                'type'=>'color'
            ],
            [
                'title' => __('Text Color', 'wpt_pro'),
                'selector' => 'a.wpt_woo_add_cart_button',
                'property' => 'color',
                'value'    => '',
                'type'=>'color'
            ],
            [
                'title' => __('Text Hover Color', 'wpt_pro'),
                'selector' => 'a.wpt_woo_add_cart_button:hover',
                'property' => 'color',
                'value'    => '',
                'type'=>'color'
            ],
            [
                'title' => __('Padding', 'wpt_pro'),
                'selector' => 'a.wpt_woo_add_cart_button',
                'property' => 'padding',
                'placeholder' => 'eg: 10px',
            ],
        ]
    ],
    'pagination'  =>[
        'title' => 'Pagination',
        'item'  => [
            [
                'title' => __('Active Color', 'wpt_pro'),
                'selector' => '.wpt_table_pagination a.page-numbers.current',
                'property' => 'background-color',
                'value'    => '',
                'type'=>'color'
            ],
            [
                'title' => __('Hover Color', 'wpt_pro'),
                'selector' => '.wpt_table_pagination a:hover',
                'property' => 'background-color',
                'value'    => '',
                'type'=>'color'
            ],
            [
                'title' => __('Border Color', 'wpt_pro'),
                'selector' => '.wpt_tspan.page-numbers.current, a.page-numbers.current',
                'property' => 'border-color',
                'value'    => '',
                'type'=>'color'
            ],
            [
                'title' => __('Text Color', 'wpt_pro'),
                'selector' => 'a.page-numbers, span.page-numbers',
                'property' => 'color',
                'value'    => '',
                'type'=>'color'
            ],
            [
                'title' => __('Active Text Color', 'wpt_pro'),
                'selector' => '.wpt_tspan.page-numbers.current, a.page-numbers.current',
                'property' => 'color',
                'value'    => '',
                'type'=>'color'
            ],
            [
                'title' => __('Alignment', 'wpt_pro'),
                'selector' => '.wpt_table_pagination',
                'property' => 'text-align',
                'value'    => '',
                'type'=>'select',
                'options' => [
                    '' => 'Blank (Default)',
                    'center' => 'Center',
                    'left' => 'Left',
                    'right' => 'Right',
                
                ],
            ],
        ]
    ],
    'advance_search'  =>[
        'title' => 'Advance Search',
        'item'  => [
            [
                'title' => __('Keywords Field Width', 'wpt_pro'),
                'selector' => '.wpt_search_box .search_single .search_single_column',
                'property' => 'width',
                'value'    => '100%',
                'type'=>'select',
                'options' => [
                    '' => 'Blank (Default)',
                    '33.33%' => '33.33%',
                    '50%' => '50%',
                    '100%' => '100%',
                
                ],
            ],
            [
                'title' => __('Keywords Field Alignment', 'wpt_pro'),
                'selector' => '.wpt_search_box .search_single .search_single_column',
                'property' => 'width',
                'value'    => '',
                'type'=>'select',
                'options' => [
                    '' => 'Blank (Default)',
                    'left' => 'Left',
                    'none' => 'None',
                    'right' => 'Light',
                
                ],
            ],
        ]
    ],
    'selected_element'  =>[
        'title' => 'Special Elements',
        'item'  => [
            [
                'title' => __('Product Title Font Size', 'wpt_pro'),
                'selector' => 'a.wpt_product_title_in_td',
                'property' => 'font-size',
                'value'    => '',
            ],
            [
                'title' => __('Product Title Text Align', 'wpt_pro'),
                'selector' => 'a.wpt_product_title_in_td',
                'property' => 'text-align',
                'value'    => '',
            ],
            [
                'title' => __('Product Title Font weight', 'wpt_pro'),
                'selector' => 'a.wpt_product_title_in_td',
                'property' => 'font-weight',
                'value'    => '',
            ],
            [
                'title' => __('Product Title Color', 'wpt_pro'),
                'selector' => 'a.wpt_product_title_in_td',
                'property' => 'color',
                'value'    => '',
                'type'=>'color'
            ],
            [
                'title' => __('Product Title Hover Color', 'wpt_pro'),
                'selector' => 'a.wpt_product_title_in_td:hover',
                'property' => 'color',
                'value'    => '',
                'type'=>'color'
            ],
            [
                'title' => __('Price Color', 'wpt_pro'),
                'selector' => 'td.td_or_cell .amount',
                'property' => 'color',
                'value'    => '',
                'type'=>'color'
            ],
            
            [
                'title' => __('Price Hover Color', 'wpt_pro'),
                'selector' => 'td.td_or_cell .amount:hover',
                'property' => 'color',
                'value'    => '',
                'type'=>'color'
            ],
            
            [
                'title' => __('Price Currency Color', 'wpt_pro'),
                'selector' => 'td.td_or_cell .amount .woocommerce-Price-currencySymbol',
                'property' => 'color',
                'value'    => '',
                'type'=>'color'
            ],
            [
                'title' => __('Price Font weight', 'wpt_pro'),
                'selector' => 'td.td_or_cell .amount',
                'property' => 'font-weight',
                'value'    => '',
            ],
            
        ]
    ],
    'others'  =>[
        'title' => 'Others',
        'item'  => [
            [
                'title' => __('Footer Background Color', 'wpt_pro'),
                'selector' => '.all_check_footer',
                'property' => 'background-color',
                'value'    => '',
                'type'=>'color'
            ],
            [
                'title' => __('Pouup Background Color', 'wpt_pro'),
                'selector' => 'div.wpt_notice_board div.woocommerce-message',
                'property' => 'background-color',
                'value'    => '',
                'type'=>'color'
            ],
            [
                'title' => __('Pouup Text Color', 'wpt_pro'),
                'selector' => 'div.wpt_notice_board div.woocommerce-message',
                'property' => 'color',
                'value'    => '',
                'type'=>'color'
            ],
            // [
            //     'title' => __('Table Statsbar Show/Hide', 'wpt_pro'),
            //     'selector' => '.wpt-stats-report',
            //     'property' => 'display',
            //     'value'    => '',
            //     'type'=>'select',
            //     'options' => [
            //         '' => 'Show (Default)',
            //         'none' => 'Hide',
                
            //     ],
            // ],
        ]
    ],
];

// var_dump(Design_Tab_Generate::get_args()['head']);


global $post;

/**
 * To add new field and in Design tab as well as
 * working for new selection for CSS/Style Apply
 * 
 * To get Understand, First See original array of $f_args ($fields_args actually)
 * Here Available:
 * section -> section name -> items (item name/title,selector,property,default value, type)
 * CSS Style will generate automatically.
 * We already used a class for making cSS. using class: Inline_Css_Generator
 * 
 * @Hook Filter wpt_design_tab_fields
 * @since 8.0.9.1
 * @author Saiful Islam <codersaiful@gmail.com>
 */
$f_args = apply_filters( 'wpt_design_tab_fields', $f_args, $post->ID );
Design_Tab_Generate::add_args($f_args);
// Design_Tab_Generate::add_section('new_section','My Section');
// $item = [
//     'title' => __('Title', 'wpt_pro'),
//     'selector' => 'your-selector',
//     'property' => 'property',
//     'value'    => '',
//     'type'=>'text'
// ];
// Design_Tab_Generate::add_item('new_section',$item);
// Design_Tab_Generate::add_item('new_section',$item);
// Design_Tab_Generate::add_item('new_section',$item);
Design_Tab_Generate::set_post_id($post->ID)->show_form();
