<?php
add_filter('plugin_action_links_' . WOO_Product_Table::getPath('PLUGIN_BASE_FILE'), 'wpt_pro_add_action_links');

if( !function_exists( 'wpt_pro_add_action_links' ) ){
    /**
     * For showing configure or add new link on plugin page
     * It was actually an individual file, now combine at 4.1.1
     * @param type $links
     * @return type
     */
    function wpt_pro_add_action_links($links) {
        $hello[] = '<a href="' . admin_url( 'post-new.php?post_type=wpt_product_table' ) . '" title="' . esc_attr__( 'Add new Shortcode', 'wpt_pro' ) . '">' . esc_html__( 'Create Table', 'wpt_pro' ).'</a>';
        $hello[] = '<a href="' . admin_url( 'edit.php?post_type=wpt_product_table&page=woo-product-table-config' ) . '" title="' . esc_attr__( 'Configure for Universal', 'wpt_pro' ) . '">' . esc_html__( 'Configure', 'wpt_pro' ) . '</a>';
        $hello[] = '<a href="https://codeastrology.com/support/?utm_source=Product+Table+EditPage&utm_medium=Pro+Version" title="' . esc_attr__( 'CodeAstrology Support', 'wpt_pro' ) . '" target="_blank">'.esc_html__( 'Support','wpt_pro' ).'</a>';
        return array_merge( $hello, $links );
    }                                       
}


if( !function_exists( 'wpt_pro_admin_menu' ) ){
    
    /**
     * Set Menu for WPT (Woo Product Table) Plugin
     * It was actually an individual file, now combine  at 4.1.1
     * 
     * @since 1.0
     * 
     * @package Woo Product Table
     * 
     * Pro Feature Menu removed, when installed pro. at V7.0.9.6
     */
    function wpt_pro_admin_menu() {
        
        remove_submenu_page('edit.php?post_type=wpt_product_table', 'wpt_fac_contact_page');
        //Pro Feature Menu removed, when installed pro. at V7.0.9.6
        remove_submenu_page('edit.php?post_type=wpt_product_table', 'wpt-pro-features');
        
        if( ! WOO_Product_Table::$direct ){
            add_submenu_page( 'edit.php?post_type=wpt_product_table', esc_html__( 'Get Updates', 'wpt_pro' ), esc_html__( 'Get Updates', 'wpt_pro' ), WPTP_CAPABILITY, 'https://wooproducttable.com/doc/gating-start/get-automatic-updates-from-codecanyon/?utm_source=Product+Table+Dashboard&utm_medium=Pro+Version' );
        }
        

    }
}
add_action( 'admin_menu', 'wpt_pro_admin_menu',50 );
