<?php
namespace WOO_PRODUCT_TABLE_PRO\Classes;

class Design_Tab_Generate{

    public static $default_type = 'text';

    public static $field_args = [];
    public static $values = [];

    public static $meta_key = 'table_style';
    public static $post_ID;



    /**
     * Main Args Actually
     * for each Item, some are default:
     * type: input,
     * class: '' //Default class already set
     * title: Default Title will come from property name
     * value: default value is empty
     * 
     * Some are Required for Item:
     * selector,
     * property
     *
     * @param [type] $field_args
     * @return void
     */
    public static function add_args( $field_args ){
        
        self::$field_args = $field_args;
        return new static;
    }
    public static function set_post_id( $post_ID ){
        self::$post_ID = $post_ID;
        return new static;
    }

    /**
     * for Getting data from Product Table post,
     * need meta ke, we can set my meta_key
     *
     * @param [type] $meta_key
     * @return void
     */
    public static function set_meta_key( $meta_key ){
        self::$meta_key = $meta_key;
        return new static;
    }

    /**
     * Adding new section for Desgin Style Tab
     * 
     *
     * @param String $section_key such as 'header' and title: Table Header
     * @param String $section_title
     * @return void
     */
    public static function add_section( String $section_key, String $section_title = '' ){
        self::$field_args[$section_key] = [
            'title' => $section_title,
            'item'  => [],
        ];
        return new static;
    }

    /**
     * Adding new Iteam using method
     *
     * @param String $section_key
     * @param Array $item
     * @return void
     */
    public static function add_item( String $section_key, Array $item ){
        $bool_section = self::$field_args[$section_key] ?? false;
        if( ! $bool_section ){
            echo "<p class='wpt-design-tab-error'>Section ($section_key) is not exist.</p>";
            return;
        }

        $current_items = self::$field_args[$section_key]['item'] ?? null;
        
        if( ! $current_items ){
            self::$field_args[$section_key]['item'] = [];
        }
        
        if( ! is_array( $current_items ) ){
            self::$field_args[$section_key]['item'] = [];
        }
        
        $current_items = self::$field_args[$section_key]['item'] ?? [];
        
        self::$field_args[$section_key]['item'] = array_merge($current_items,[$item]);
        return new static;
    }


    /**
     * Compolsury for Getting database value.
     * without this method,
     * There will not show saved/daabase value inside form
     *
     * @return vaoid
     */
    public static function set_value_to_args(){
        $values = get_post_meta(self::$post_ID, self::$meta_key, true);
        
        if( ! is_array( $values ) ) return;
        self::$values = $values;
        
    }




    /**
     * Final Output Showing here
     * 
     * Some point:
     * * $g_key mean, group key. Actually we call group to each section
     * * Need to call at the end actually
     *
     * @return void
     */
    public static function show_form(){
        self::set_value_to_args();
        

        if( ! self::$post_ID ){
            echo 'POST ID for getting meta field is not found. Use: Design_Tab_Generate::set_post_id($ID);';
            // return;
        }

        ?>
        <div class="wpt-design-tab-area-wrapper">
        <?php
        //$g_key mean, group key. Actually we call group to each section
        foreach( self::$field_args as $g_key => $group ){
            
            $title = $group['title'] ?? '';
            $g_key = $g_key ?? '';
            $items = $group
            ?>
            <div class="section ultraaddons-panel">
                <h1 class="with-background dark-background title-<?php echo $g_key; ?>"><?php echo esc_html( $title ); ?></h1>
                <table class="ultraaddons-table ultraaddons-table-<?php echo $g_key; ?>">
                <?php self::generate_rows( $g_key ); ?>
                </table>
            </div>
            
            <?php 
        }
        ?>

        </div>
        <?php
    }

    /**
     * actually  we have extract, so we got variable
     * from Iteam Array
     * 
     * Render input's Row
     * it's type can be text and number actually
     * 
     * @param Array $item
     * @return void
     */
    public static function render_input( $item ){
        
        extract($item);
        $my_class = $item['class'] ?? '';
        $class = $type == 'color' ? 'wpt_color_picker' : $my_class;
        $type = $type == 'number' ? 'number' : 'text';

        ?>
        <tr>
            <th scope="row">
                <label><?php esc_html_e( $title ); ?> </label>
            </th>
            <td>
                
                <input class="regular-text <?php echo $class; ?>" 
                type="<?php echo $type; ?>" 
                name="table_style[<?php echo $selector; ?>][<?php echo $property; ?>]" 
                placeholder="<?php echo esc_attr( $placeholder ); ?>"
                value="<?php echo $value; ?>">


                <?php if( ! empty( $desc ) ){ ?>
                    <p class="description"><?php echo esc_html( $desc ); ?></p>
                <?php } ?>
            </td>
        </tr>
        <?php
    }
    /**
     * Render Select Tab
     * Here Need:
     * type,
     * options,
     * multiple:bool  //For now, I will work only for non multiple
     * 
     * Optional:
     * class
     * value also
     * 
     * it's type can be text and number actually
     * 
     * @param Array $item
     * @return void
     */
    public static function render_select( $item ){
        extract($item);
        
        $class = $item['class'] ?? '';
        $type = $type == 'number' ? 'number' : 'text';
        if( ! isset( $options ) ||  ! is_array( $options ) ){
            echo "<p class='wpt-design-tab-error'>$title($selector): options is not founded or is not an array.</p>";
            return;
        }
        ?>
        <tr>
            <th scope="row">
                <label><?php esc_html_e( $title ); ?> </label>
            </th>
            <td>
                <select
                    class="ua-select <?php echo $class; ?>"
                    name="table_style[<?php echo $selector; ?>][<?php echo $property; ?>]">
                    <?php
                    foreach( $options as $op_key => $option ){
                        $opt_val = is_string( $option ) ? $option : '';
                        //$value has come from $item['value'] using extract function of this array.
                        $selected = $op_key == $value ? 'selected' : '';
                    ?>
                    <option value="<?php echo $op_key; ?>" <?php echo $selected; ?>><?php echo $opt_val; ?></option>
                    <?php 
                    }
                    ?>
                </select>
           
                <?php if( ! empty( $desc ) ){ ?>
                    <p class="description"><?php echo esc_html( $desc ); ?></p>
                <?php } ?>
                
            </td>
        </tr>
        <?php
    }

    /**
     * Each Item will generate a row
     * Here we already set default value for type.
     * We need allways $item[type];
     *
     * @param Arra $item Each item's array where available selector,property
     * @return void
     */
    public static function distribute_render( $item ){
        $type = $item['type'] ?? self::$default_type;
        switch($type){
            case 'input':
            case 'text':
            case 'color':
            case 'number':
                self::render_input( $item );
                break;
            case 'select':
                self::render_select( $item );
                break;
            default:
                $item['type'] = self::$default_type;
                self::render_input( $item );
                break;
        }
    }
    /**
     * Generate Each row of table of design Tab's form
     * Take here group key like: head,body etc and will work using main self::get_args()
     * 
     * Some elment set as default so that no issue fond on distribute method
     * type,
     * value,
     * desc: It's actually Description
     * title: It will always come 
     *
     * @param string $g_key
     * @return void
     */
    public static function generate_rows( $g_key = 'body'  ){
        $items = self::$field_args[$g_key]['item'] ?? [];
        if( ! is_array( $items ) ) return;
        
        foreach( $items as $item ){
            
            if( empty( $item['selector'] ) || empty( $item['property'] ) ) continue;
            $selector = $item['selector'];
            $property = $item['property'];
            $value = self::$values[$selector][$property] ?? null;
            $default_value = $item['value'] ?? '';
            
            
            $item['type'] = ! empty( $item['type'] ) ? $item['type'] : self::$default_type;
            $item['value'] = $value ?? $default_value;
            $item['desc'] = $item['desc'] ?? '';
            
            $item['placeholder'] = $item['placeholder'] ?? '';
            $item['title'] = ! empty( $item['title'] ) ? $item['title'] : $item['property'];
            self::distribute_render( $item );
        }
    }


    public static function get_args(){
        return static::$field_args;
    }


}