<?php 
namespace WOO_PRODUCT_TABLE_PRO\Classes;

/**
 * Inlince CSS Generator
 * 
 * from Design tab of Each Product Table
 * 
 * @author Saiful Islam <codersaiful@gmail.com>
 * @author Fazle bari <fazlebarisn@gmail.com>
 * 
 * @since 8.0.8.1
 */
class Inline_Css_Generator{

    public $css_output = null;
    public $disabled_css_gen = [
        // 'tr.wpt_table_head th' //etate somossa hobe, onekgulo aitem disable hoye jacche. notun somadhan ber korte hobe
    ];
    
    public $disabled_table_id = [
        'div.wpt_notice_board div.woocommerce-message',
    ];

    /**
     * Action Hook: wpto_action_after_table 
     *
     * @return void
     */

     public function __construct()
     {
        add_action('wpto_action_after_table' , [$this, 'wpto_action_inject_styles']);
     }

     public function wpto_action_inject_styles($table_ID){
        
        $ID = $temp_number = $table_ID;
        $this->temp_number = $this->ID = $table_ID;
        $table_style = get_post_meta( $ID, 'table_style', true );
        $custom_css_code = '';
        if( is_array($table_style) ){

            $custom_style = $table_style;
            unset($custom_style['template']);
            $custom_css_code .= "<style>\n";
            $this->css_output .= "<style>\n";
            foreach($custom_style as $selector=>$properties){
                if( in_array($selector, $this->disabled_css_gen) ) continue; //No need CSS gen for this selector

                $custom_css_code .= $this->property_to_style($selector, $properties);
                $this->css_output .= $this->property_to_style($selector, $properties);
                
            }
            $custom_css_code .= "\n</style>";
            $this->css_output .= "\n</style>";
        }
        // var_dump($custom_css_code);
        echo $this->css_output;//$custom_css_code;
     }

    public function property_to_style($selector, $properties){
            $custom_css_code = '';
            $selector = str_replace('{', '[', $selector); 
            $selector = str_replace('}', ']', $selector);  
            $selector = str_replace('%', '+', $selector); 
            
            $my_selector = '#table_id_'.$this->temp_number . ' ' . $selector;
            if( in_array($selector, $this->disabled_table_id) ){
                $my_selector = $selector;
            }
            
            $full_selector = $my_selector .'{';
            
            $full_selector = str_replace( ',', ',#table_id_'.$this->temp_number . ' ', $full_selector );
            $custom_css_code .= $full_selector;
            foreach( $properties as $property=>$value ){
                $custom_css_code .= !empty( $value ) ? $property . ': ' . $value . "!important;" : '';
            }
            $custom_css_code .= "} \n";
            return $custom_css_code;
    }
    
}

new Inline_Css_Generator();