<?php 
namespace WOO_PRODUCT_TABLE_PRO\Inc;

use WOO_PRODUCT_TABLE_PRO\Core\Base;
use WOO_PRODUCT_TABLE_PRO\Inc\Features\Basics;
use WOO_PRODUCT_TABLE_PRO\Inc\Features\Templates;
use WOO_PRODUCT_TABLE_PRO\Inc\Features\Search_Extra;
use WOO_PRODUCT_TABLE_PRO\Inc\Features\Advance_Search;
use WOO_PRODUCT_TABLE_PRO\Inc\Features\Casecade_Handle;
use WOO_PRODUCT_TABLE_PRO\Inc\Features\Variable_Product;
use WOO_PRODUCT_TABLE_PRO\Inc\Features\Args_Manipulation;
use WOO_PRODUCT_TABLE_PRO\Inc\Features\ACF_Shortcode_Render;

use WOO_PRODUCT_TABLE_PRO\Inc\Features\Test;

class Feature_Loader extends Base{

    public function __construct()
    {
        $basics = new Basics();
        $basics->run();

        if ( class_exists( 'ACF' ) ) {
            $acf_shortcode = new ACF_Shortcode_Render();
            $acf_shortcode->run();
        }
        
        //Advance Search Feature, where user able to search by custom field or price etc.
        $adv_search = new Advance_Search();
        // $adv_search->run();

        $search_extra = new Search_Extra();
        $search_extra->run();

        $templates = new Templates();
        $templates->run();

        $arg_manipulation= new Args_Manipulation();
        $arg_manipulation->run();

        $variable_table = new Variable_Product();
        $variable_table->run();

        
        $casecade = new Casecade_Handle();
        $casecade->run();


        
    }


}