<?php 
namespace WOO_PRODUCT_TABLE_PRO\Inc\Features;

use WOO_PRODUCT_TABLE\Inc\Shortcode;
use WOO_PRODUCT_TABLE_PRO\Core\Base;


class Args_Manipulation extends Base{
    
    public function run(){
        $this->filter('wpt_query_args',1,10,'sort_by_manipulation');
        $this->filter('wpt_query_args',2,10,'on_sale_manipulation');
    }

    public function sort_by_manipulation( $args ){
            
        $_orderby = $args['orderby'] ?? '';
        
        switch( $_orderby ){
            case 'price':
                    $args['orderby'] = 'meta_value_num';
                    $args['order'] = 'asc';
                    $args['meta_key'] = '_price';
                break;
            case 'price-desc':
                    $args['orderby'] = 'meta_value_num';
                    $args['order'] = 'desc';
                    $args['meta_key'] = '_price';
                break;
            case 'rating':
                    $args['orderby'] = 'meta_value_num';
                    $args['order'] = 'desc';
                    $args['meta_key'] = '_wc_average_rating';
               break;
            case 'popularity':
                    $args['orderby'] = 'meta_value_num';
                    $args['order'] = 'desc';
                    $args['meta_key'] = 'total_sales';
                break;
            case 'date':
                    $args['order'] = 'desc';
                break;
        }
        
    return $args;
    }

    /**
     * On Sell manipulation has been compplete.
     * We have taken help from $obj->args_ajax_called
     * 
     * We only called it after call in ajax.
     * otherwise, it will not do anything.
     *
     * @param array $args
     * @param Shortcode $shortcode
     * @return array
     */
    public function on_sale_manipulation( $args,Shortcode $shortcode ){
        if( ! $shortcode->args_ajax_called) return $args;
        $on_sale = $args['on_sale'] ?? false;
        if( $on_sale !== 'sale_product' ) return $args;
        $includes = $shortcode->basics['post_include'] ?? [];
        $sale_products = wc_get_product_ids_on_sale();

        $sale_products = $sale_products && is_array( $sale_products ) && ! empty( $includes ) && is_array( $includes ) ? array_intersect( $includes, $sale_products ) : $sale_products;
        $args['post__in'] = $sale_products;
        return $args;
    }

}    