<?php 
namespace WOO_PRODUCT_TABLE_PRO\Inc\Features;

use WOO_PRODUCT_TABLE_PRO\Core\Base;


class Basics extends Base{
    public $shortcde_text;
    /**
     * IIf found post meta from Advance search box.
     *
     * @var mixed
     */
    public $search_post_meta;

    /**
     * there are two type key search.
     * one is: postsmeta and second is: posts 
     *
     * @var mixed
     */
    public $search_posts;
    public function run(){

        $this->shortcde_text = $this->shortcode_base->shortcde_text;
        
        $this->filter('body_class');
        
        $this->filter( 'wpt_query_args', 2, 10, 'args_organize_adv_search' );
    }
    public function body_class($class){
        global $post;

        if( isset($post->post_content) && has_shortcode( $post->post_content, $this->shortcde_text ) ) {
            $class[] = 'wpt_table_body_pro';
            $class[] = 'wpt_pro_table_body';
        }
        return $class;
    }

    /**
     * This is for Advance Search 
     * When we need advance search, then we have to organize s keyword.
     * Actually for Advance search, we need $q[s] to be empty, but if we unset it, 
     * postw_where will not work actually
     * 
     *
     * @param [type] $args
     * @param [type] $shortcode
     * @return args
     */
    public function args_organize_adv_search( $args, $shortcode ){

        $type = $args['wpt_query_type'] ?? '';
        if( $type !== 'search' ) return $args;


        $search_from = $shortcode->search_n_filter['search_from'] ?? [];
        $s = $args['s'] ?? '';
        $s = ltrim($s);
        $s = rtrim( $s );
        $args['wpt-s'] = $s;
        /**
         * Question can come: why need wpt_raw_sql
         * Actually it's just a given name.
         * When we will choose Search_From from both post and post_meta, We will pass 
         * $q['wpt_raw_sql'] to detect at add_filter( 'posts_where', 'wpt_custom_search_where',10 ,2 );
         * 
         * Actually if only select from post_meta, we will query by WordPress base/default query, then we will
         * not query with sql query
         * currently working for it at functions.php file under
         * add_filter( 'posts_where', 'wpt_custom_search_where',10 ,2 );
         * 
         * ***********************
         * WHEN NEED 'wpt_raw_sql'? 
         * ***********************
         * Actually when user will choose from both from post defatul and post meta 
         * like: post_title, _sku etc, then we will query user raw sql or custom query by sql.
         * 
         * @since 8.1.7.1 
         * @author Saiful Islam <codersaiful@gmail.com>
         */
        $args['search_from'] = $args['wpt_raw_sql'] = false;

        /**
         * filter 'posts_join' is no need always, for quality checking, we will 
         * check by this query var. 
         * if true, we will add following join.
         * like:
         * add_filter('posts_join', 'wpt_custom_search_join', 10, 2 );
         * currently added in functions.php of pro
         * 
         * later I will transfer it in Class.
         * 
         * @author Saiful Islam <codersaiful@gmail.com>
         * @since 8.1.2.0
         */
        $args['wpt_join'] = false;
        if( is_array( $search_from ) && count( $search_from ) > 0 ){
            $this->search_post_meta = array_filter($search_from, function( $val ){
                return $val === 'postmeta';
            });
            
            $this->search_posts = array_filter($search_from, function( $val ){
                return $val === 'posts';
            });
            unset($args['s']);
            $args['wpt_join'] = false;
        }


        if( empty( $this->search_post_meta ) && empty( $this->search_posts ) ){
            $args['s'] = $s;
            $args['wpt_join'] = true;
            return $args;
        }

        /**
         * Why set $compare variable set here, Actually
         * if emty both, ne need Q['wpt_compare'],
         * Thats why we made it here.
         * and I use it inside add_filter('posts_join', 'wpt_custom_search_join', 10, 2 );
         */
        $compare = $shortcode->search_n_filter['search_form_compare'] ?? false;
        $args['wpt_compare'] = $compare;

        //If choose from both type, means: chosen from post and post_meta like: post_title, _sku,_price
        if( ! empty( $this->search_post_meta ) && ! empty( $this->search_posts ) ){
            unset($args['s']);
            $args['wpt_raw_sql'] = true;
            $args['wpt_join'] = true;
            $args['search_from'] = $this->search_posts + $this->search_post_meta;

            return $args;
        }

        
        

        if( empty( $this->search_posts ) && ! empty( $this->search_post_meta ) && is_array( $this->search_post_meta ) ){
            
            unset($args['s']);
            $args['wpt_join'] = false;

            $compare = $compare == 'on' ? '==' : 'LIKE';
            $posts_metas = array_keys( $this->search_post_meta );
            foreach($posts_metas as $meta){
                $args['meta_query'][$meta] = array(
                    'key' => $meta,
                    'value' => $s,
                    'compare' => $compare,//'LIKE'
                );
            }
            $args['meta_query']['relation'] = 'OR';

            return $args;
        }
        
        if( ! empty( $this->search_posts ) && is_array( $this->search_posts ) ){
            $args['search_from'] = $this->search_posts;
        }

        return $args;
        
    }
}