<?php 
namespace WOO_PRODUCT_TABLE_PRO\Inc\Features;

use WOO_PRODUCT_TABLE\Inc\Shortcode;

class Casecade_Handle extends Shortcode{
    public $stats;
    public $taxonomies;
    public $temp_tax_query = [];
    public $temp_page_number;
    public $temp_per_page;

    public function run(){
        $this->stats = $this->base_config['advance_cascade_filter'] ?? false;
        
        if( ! boolval( $this->stats )  ) return;

        add_action('wp_ajax_wpt_cascade_filter', [$this, 'handle']);
        add_action('wp_ajax_nopriv_wpt_cascade_filter', [$this, 'handle']);
        
    }

    public function handle(){
        $atts = $this->set_atts();

        $args = $_POST['data']['args'] ?? [];
        
        (int) $this->temp_page_number = $_POST['data']['others']['page_number'] ?? 10;
        
        $args = $this->arrayFilter( $args );
        $temp_args = $args;
        unset($temp_args['base_link']);

        //It's need to the beginning of this process.
        $this->assing_property($atts); 
        if( is_array( $temp_args ) && ! empty( $temp_args ) ){
            if( $this->whole_search ){

                unset($this->args['post__in']);
                unset($this->args['post__not_in']);

                unset($this->args['tax_query']);
                unset($this->args['meta_query']);
            }
            $this->args = array_merge( $this->args, $temp_args );
        }
        $this->temp_tax_query = $this->args['tax_query'] ?? [];
        unset($this->temp_tax_query['relation']);
        if( ! empty( $this->temp_tax_query ) ){
            $this->args['posts_per_page'] = '-1';
        }else{
            if($this->temp_page_number < 10){
                $this->temp_page_number = 10;
            }
            $this->args['posts_per_page'] = (int) $this->posts_per_page * $this->temp_page_number;
        }

        $this->taxonomies = $this->search_n_filter['taxonomy_keywords'] ?? [];

        if (empty($this->args) || empty($this->taxonomies)) {
            echo "";
            die();
        }
        
        $called_taxs = $this->args['tax_query'] ?? [];
        if ( ! empty($called_taxs ) ) {
            $called_taxs = array_map(function ($arr) {
                return $arr['taxonomy'] ?? [];
            }, $called_taxs);
            unset($called_taxs['relation']);
            $called_taxs = array_values($called_taxs);
        }
        $called_taxs = array_flip($called_taxs);
        $taxs = $allTax = array_flip($this->taxonomies);

        foreach ($called_taxs as $tax_key => $n) {
            unset($taxs[$tax_key]);
        }


        $called_taxs = array_flip($called_taxs);
        $allTax = array_flip($allTax);
        $fTaxbyQuery = [];
        
        if( empty( $allTax ) ){
            wp_send_json( $fTaxbyQuery );
            die();
        }
        
        $posts = get_posts($this->args);
        // die();
        
        foreach ($posts as $m_post) {
            $post_id = $m_post->ID;
            foreach ($allTax as $taxonomy) { //$allTax
                $th_term = get_the_terms($post_id, $taxonomy);

                if ( ! empty( $th_term ) ) {
                    foreach ($th_term as $each_th_term) {
                        //$slug = $each_th_term->slug;
                        $term_id = $each_th_term->term_id;
                        $name = $each_th_term->name;
                        $fTaxbyQuery[$taxonomy][$term_id] = $name;
                    }
                }

            }

        }


        wp_reset_query();
        wp_reset_postdata();
        
        $finals = [];
        foreach( $this->taxonomies as $each_tax ){
            $finals[$each_tax] = $fTaxbyQuery[$each_tax] ?? [];
        }

        wp_send_json( $finals );
        die();
    }

    /**
     * Woo Product Table
     * setting ATTS for Ajax Request
     * to work by this method,
     * need to send $_POST method
     * Where NEED Available $_POST['table_id']
     * 
     * 
     * @param string $method To be $_POST['table_id'] 
     * @return void
     */
    public function set_atts(){
        $table_id = $_POST['data']['table_id'] ?? 0;
        $table_id = (int) $table_id;
        $atts = ['id'=> $table_id];
        return $atts;
    }

    

}