<?php 
namespace WOO_PRODUCT_TABLE_PRO\Inc\Features;

use WOO_PRODUCT_TABLE\Inc\Shortcode;
use WOO_PRODUCT_TABLE_PRO\Core\Base;

/**
 * Extra search of Search Box Area
 * 
 * Speciall for Pro Version
 * 
 * Such: Extra Search Field beside Serch Input Box
 * as well as Search by Meta field, where we have used filter wpt_after_searchbox
 */
class Search_Extra extends Base{

    public function run(){
        $this->action('wpt_search_box',1,9,'on_sale_field');
        $this->action('wpt_search_box');

        $this->action('wpt_after_searchbox');
        
    }
    public function on_sale_field( Shortcode $shortcode ){
        
        $html = '';
        $meta =  $shortcode->search_n_filter;

        
        $fields = $meta['fields'] ?? array();
        if( empty( $fields['on_sale'] ) ) return;
        
        $sale = isset( $_GET['sale'] ) ? sanitize_text_field( $_GET['sale'] ) : '';
        $single_keyword = $shortcode->_config['search_box_sale'] ?? __( 'Sale', 'wpt_pro' );
        
        /**
         * @Hook Filter Hook for change search box sale option
         * 
         * @since 8.0.5.0
         * @author Saiful Islam <codersaiful@gmail.com>
         */
        $on_sale_options = apply_filters( 'wpto_search_sale_option', array(
            '' => __( 'Default','wpt_pro' ),
            'sale_product' => __( 'On Sale','wpt_pro' ),
        ), $shortcode->table_id, $shortcode->_config );

        $html .= "<div class='search_single_column search_single_order'>";
        $html .= '<label class="search_keyword_label single_keyword" for="order_' . $shortcode->table_id . '">' . $single_keyword . '</label>';
        $html .= '<select data-key="on_sale" id="order_' . $shortcode->table_id . '" class="query_box_direct_value select2" >  ';
        $html .= '<option value="">'. esc_html( $on_sale_options[''] ).'</option>';
        $html .= '<option value="sale_product" '. wpt_check_sortOrder( $sale, 'sale_product' ) .'>'. esc_html( $on_sale_options['sale_product'] ) .'</option>';
        
        $html .= '</select>';

        $html .= "</div>";// End of .search_single_column
        echo $html;
    }

    public function wpt_search_box( Shortcode $shortcode ){
        
        $html = '';
        $meta =  $shortcode->search_n_filter;
        $fields = $meta['fields'] ?? array();
        $orderby = $shortcode->orderby;
        
        if( ! empty( $fields['orderby'] ) ){
        $orderby = isset( $_GET['orderby'] ) ? sanitize_text_field( $_GET['orderby'] ) : $orderby;
        $single_keyword = $shortcode->_config['search_box_orderby'] ?? '';
        
        $catalog_orderby_options = apply_filters(
			'woocommerce_catalog_orderby',
			array(
				'menu_order' => __( 'Default sorting', 'woocommerce' ),
				'popularity' => __( 'Sort by popularity', 'woocommerce' ),
				'rating'     => __( 'Sort by average rating', 'woocommerce' ),
				'date'       => __( 'Sort by latest', 'woocommerce' ),
				'price'      => __( 'Sort by price: low to high', 'woocommerce' ),
				'price-desc' => __( 'Sort by price: high to low', 'woocommerce' ),
                //New added @since 3.2.3.18.0.8.1
                // 'featured_products' => __( 'Sort by Featured Products', 'woocommerce' ),
			)
		);
        
        $html .= "<div class='search_single_column search_single_sort search_single_order_by'>";
            $html .= '<label class="search_keyword_label single_keyword" for="order_by' . $shortcode->table_id . '">' . $single_keyword . '</label>';

            $html .= '<select data-key="orderby" id="order_by_' . $shortcode->table_id . '" class="query_box_direct_value select2" >';
            

            $html .= '<option value="">'.esc_html__( 'None','wpt_pro' ).'</option>';
            // $html .= '<option value="name" '. wpt_check_sortOrder( $orderby, 'name' ) .'>'.esc_html__( 'Name','wpt_pro' ).'</option>';
            foreach ( $catalog_orderby_options as $id => $name ) :
            $html .= '<option value="' . $id . '" '. wpt_check_sortOrder( $orderby, $id ) .'>'. esc_html( $name ) .'</option>';
            endforeach;

            
            $html .= '<option value="name" '. wpt_check_sortOrder( $orderby, 'name' ) .'>'.esc_html__( 'Sort by name','wpt_pro' ).'</option>';
            // $html .= '<option value="menu_order" '. wpt_check_sortOrder( $orderby, 'menu_order' ) .'>'.esc_html__( 'Menu Order','wpt_pro' ).'</option>';
            // $html .= '<option value="type" '. wpt_check_sortOrder( $orderby, 'type' ) .'>'.esc_html__( 'Type','wpt_pro' ).'</option>';
            // $html .= '<option value="comment_count" '. wpt_check_sortOrder( $orderby, 'comment_count' ) .'>'.esc_html__( 'Reviews','wpt_pro' ).'</option>';
            $html .= '</select>';
        $html .= "</div>";
        }
        if( ! empty( $fields['order'] ) ){
        $shortcode->order = isset( $_GET['order'] ) ? sanitize_text_field( $_GET['order'] ) : $shortcode->order;
        $single_keyword = $shortcode->_config['search_box_order'] ?? ''; 
        $html .= "<div class='search_single_column search_single_order'>";
            $html .= '<label class="search_keyword_label single_keyword" for="order_' . $shortcode->table_id . '">' . $single_keyword . '</label>';
            $html .= '<select data-key="order" id="order_' . $shortcode->table_id . '" class="query_box_direct_value select2" >  ';
            $html .= '<option value="ASC" '. wpt_check_sortOrder( $shortcode->order, 'ASC' ) .'>'.esc_html__( 'ASCENDING','wpt_pro' ).'</option>';
            $html .= '<option value="DESC" '. wpt_check_sortOrder( $shortcode->order, 'DESC' ) .'>'.esc_html__( 'DESCENDING','wpt_pro' ).'</option>';
            $html .= '<option value="random" '. wpt_check_sortOrder( $shortcode->order, 'random' ) .'>'.esc_html__( 'Random','wpt_pro' ).'</option>';
            $html .= '</select>';

        $html .= "</div>";// End of .search_single_column
        }
        
        echo $html;
    }

    /**
     * Speciall for Meta Field Wise search
     * Actually custom field search
     * 
     *
     * @param Object $shortcode
     * @return void
     */
    public function wpt_after_searchbox( Shortcode $shortcode ){
        $meta =  $shortcode->search_n_filter;
        
        if( isset( $meta['cf_search_box'] ) && $meta['cf_search_box'] == 'no' ){
            return;
        }
       
        
        
        // $data = get_post_meta( $shortcode->table_id, '_cf_filter', true );
        $data = $shortcode->get_meta('_cf_filter');
        if( empty( $data ) || ! is_array( $data ) ) return;
        
        // $label_text = get_post_meta($shortcode->table_id,'_cf_filter_text_data',true );
        $label_text = $shortcode->get_meta('_cf_filter_text_data');

        $choose_text = isset( $label_text['choose_text'] ) && !empty( $label_text['choose_text'] ) ? $label_text['choose_text'] : "Choose";
        $multiple_bool = isset( $label_text['choose_text'] ) && empty( $label_text['choose_text'] ) ? true : false;
        $multiple = apply_filters('wpt_custom_field_multiple', $multiple_bool, $shortcode->table_id );
        $multiple_txt = $multiple ? 'multiple' : '';
        
        $html = "";
        

        $inside_html = false;

        foreach( $data as $key => $items ){

            if( ! isset( $items['values'] ) || ! isset( $items['label'] ) ) continue;

            if( is_array( $items ) && is_array( $items['values'] ) ){
                $name = $items['label'];
                $item_values = $items['values'];
                $inside_html .='<div class="search_single_column cf_fielter cf_fielter_wpt">';
                $inside_html .= '<label class="search_keyword_label">' . $name . '</label>';
                $inside_html .='<select data-key="' . $key . '"  class="search_select cf_query cf_query_' . $multiple_txt . '" tabindex="-1" ' . $multiple_txt . '>';
                
                $inside_html .= ! $multiple ? '<option value="">' . $choose_text . ' ' . $name . '</option>' : '';
                foreach( $item_values as $item ){
                    $option_label = apply_filters( 'wpt_custom_field_option_label', $item, $shortcode->table_id );
                    $inside_html .='<option value="' . $item . '">' . $option_label . '</option>';
                }

                $inside_html .='</select >';
                $inside_html .= '</div>';
            }

        }
        if( $inside_html ){
            $html .= "<div id='search_box_{$shortcode->table_id}' class='wpt_search_box wpt-custom-field-search search_box_{$shortcode->table_id}'>";
            $html .= "<div class='wpt_filter_wrapper'>";
            $html .= $inside_html;
            $html .= '<button data-type="query" data-temp_number="' . $shortcode->table_id . '" id="wpt_query_search_button_' . $shortcode->table_id . '" class="button wpt_search_button query_button wpt_query_search_button wpt_query_search_button_' . $shortcode->table_id . '">Search</button>';
            $html .= "</div>";
            $html .= "</div>";
        }

        
        echo $html;
    }
}