<?php 
namespace WOO_PRODUCT_TABLE_PRO\Inc\Features;

use WOO_PRODUCT_TABLE_PRO\Core\Base;
use WOO_PRODUCT_TABLE\Inc\Shortcode_Base;


class Variable_Product extends Shortcode_Base{
    public $default_poistion = 'woocommerce_single_product_summary';

    /**
     * It's table id, which actually stored in condifigure page.
     * But Actually it's come from configuration page setting
     * 
     * 
     *
     * @var int|string
     */
    public $table_id;

    /**
     * Table Position mean, location of showing table..  
     * In Variable Product Page, Where do u want to show Table.
     * 
     * By default, I will show table at 'woocommerce_single_product_summary' of WooCommerce 
     *
     * @var [type]
     */
    public $table_position;
    public $priority = 8;

    public $product_id;

    /**
     * Pass fail of Table id and table location 
     * 
     * It will regenrate at the table_in_product_page() method and
     * will use at the render method.
     *
     * @var boolean
     */
    public $status = false;

    
    protected $attributes = [];
    protected $childrens = [];
    protected $Product_Variable;

    public function run(){
        
        if( ! $this->table_on_variable ) return;

        $this->table_position = $this->base_config['variation_table_position'] ?? $this->default_poistion;
        
        /**
         * In previous version, we added table in variable page using following hook.
         * But if a customer get/use new version of our plugin,
         * He need to removed this following hook.
         * Otherwise, there will show Double table. 
         * 
         * Why we don't remove from code, Actually for old user of free version.
         * Need that code actually.
         * 
         * @author Saiful Islam <codersaiful@gmail.com>
         */
        remove_action( 'woocommerce_single_product_summary', 'wpt_show_variation_table', 3 );

        $hook_action_possition = $this->table_position !== 'woocommerce_before_add_to_cart_form' ? 'woocommerce_single_product_summary' : 'woocommerce_before_add_to_cart_form';
        //woocommerce_single_product_summary
        //woocommerce_before_add_to_cart_form
        $this->action( $hook_action_possition, 1, 3, 'table_in_product_page' );

        $this->action('wpt_load');
        
    }

    public function table_in_product_page(){
        global $product;
        
        if( $product->get_type() !== 'variable' ) return;
        $this->product_id = $product->get_id();

        /**
         * Product Variable and Attribute will be need
         * When we will call to action hook wp_load
         * Where I will manage Mainly column setting and column ammount
         * I will add new column based on product's attribute wise 
         * column as well as column_setting for thes added new column
         * 
         */
        $this->Product_Variable = new \WC_Product_Variable( $this->product_id ); 
        $this->attributes = $this->Product_Variable->get_variation_attributes();


        $table_id = $this->table_on_variable;
        $table_id = apply_filters( 'wpto_variation_table_id', $table_id );
        $table_id = apply_filters( 'wpt_variation_table_id', $table_id );
        $this->table_id = is_numeric( $table_id ) ? (int) $table_id : false;
        
        
        if( $this->table_id && ! empty( $this->table_position ) ){
            $this->status = true;
            remove_action( 'woocommerce_single_product_summary', 'woocommerce_template_single_add_to_cart', 30 );
            
            if ( $this->table_position == 'woocommerce_single_product_summary' ) {
                $this->action($this->table_position,1,$this->priority,'render_table');
                // add_action( $this->table_position, 'wpt_woo_product_table_as_variation', 4);
            }else if ( $this->table_position == 'woocommerce_before_add_to_cart_form' ) {
				add_action('woocommerce_before_add_to_cart_form',[$this,'render_table']);
			}else{
                $this->priority = -999;
                $this->action($this->table_position,1,$this->priority,'render_table');
                // add_action( $this->table_position, 'wpt_woo_product_table_as_variation', -999);
            }
        }
        
    }

    /**
     * How I will get table_id, position in here.
     * Because, this method will call after call $this->table_in_product_page
     * which called using action hook woocommerce_single_product_summary inside run method.
     * 
     * 
     *
     * @return void
     */
    public function render_table(){
        if( ! $this->status ) return;
        // add_filter( 'wpto_table_query_args', 'wpt_variation_table_args' );
        $this->filter( 'wpt_query_args' );
        echo do_shortcode( "[Product_Table id='{$this->table_id}']" );
    }

    public function wpt_load( $shortcode ){

        if( ! is_product() ) return;
        $maArr = [];
        
        $shortcode->search_box = false;
        $shortcode->search_n_filter['cf_search_box'] = 'no';

        //Unset action column
        unset($shortcode->_enable_cols['attribute']);
        unset($shortcode->_enable_cols['product_title']);
        unset($shortcode->_enable_cols['variations']);
        // unset($shortcode->_enable_cols['variation_name']);

        
        $arrtibutes = array_keys( $this->attributes );
        if( empty( $arrtibutes ) ){
            $shortcode->table_display = false;
            add_action( 'woocommerce_single_product_summary', 'woocommerce_template_single_add_to_cart', 30 );
            return;
        }

        foreach( $arrtibutes as $key ){
            $label = wc_attribute_label($key);
            $maArr[$key] = $label;
            $shortcode->column_settings[$key] = [
                'type' => 'single_variation',
                'type_name' => 'Single Variation',
                'variation_name' => $label,
                'tag_class' => 'auto-generated_variation_column wpt-auto-gen_product_id' . $shortcode->table_id,
            ];
        }
        
        $quick_qty = $shortcode->_enable_cols['quick_qty'] ?? false;
        $action = $shortcode->_enable_cols['action'] ?? false;
        if( $quick_qty ){
            unset($shortcode->_enable_cols['quantity']);
            unset($shortcode->_enable_cols['action']);
        }else{
            $shortcode->_enable_cols['action'] = 'action';
        }
        $final_target = ! empty( $quick_qty ) ? $quick_qty : $action;
        

        $target_key = isset( $shortcode->_enable_cols['quantity'] ) ? 'quantity' : $final_target;
        $target_key = $shortcode->_enable_cols['variation_name'] ?? $target_key;
        $shortcode->_enable_cols = $this->array_insert_before( $shortcode->_enable_cols,$maArr,$target_key );
        unset($shortcode->_enable_cols['variation_name']);
    }

    public function wpt_query_args( $args ){
        //Args Management
        $product_includes = [];
        $this->childrens = $this->Product_Variable->get_children();
        foreach( $this->childrens as $per ){
            $product_includes[$per] = $per;
        }
        $args['post__in'] = $product_includes;
        $args['post_type'] = array( 'product', 'product_variation' );
        unset($args['tax_query']);
        $args['posts_per_page'] = '400';
        return $args;
    }

    

}