<?php 
/**
 * FILE WILL LOAD BASED ON CONDITION
 * 
 * FROM CONFIGURE OPTION
 * 
 * WE HAVE USED: 
 * $cascade_filter = isset( $config['advance_cascade_filter'] ) ? $config['advance_cascade_filter'] : false;
 * AND INCLUDED INSIDE includes/functions.php
 * 
 * @since 8.0.2.1
 * @author Saiful Islam <codersaiful@gmail.com>
 */


/**
 * Advance search cascade filter on ajax
 *
 * The work was done by Saiful Islam for a client and implemented by Md Rakibul Islam
 *
 * @Since 8.0.2.1
 * @author Md Rakibul Islam
 * @return void
 */
function wpt_cascade_filter()
{

    $args = $_POST["query"] ?? [];

    //available in table acctually
    $taxs = $_POST["taxs"] ?? [];


    if (empty($args) || empty($taxs)) {
        echo "";
        die();
    }

    $called_taxs = $args['tax_query'] ?? [];
    if (!empty($called_taxs)) {
        $called_taxs = array_map(function ($arr) {
            return $arr['taxonomy'] ?? [];
        }, $called_taxs);
        unset($called_taxs['relation']);
        $called_taxs = array_values($called_taxs);
    }
    $called_taxs = array_flip($called_taxs);
    $taxs = $allTax = array_flip($taxs);

    foreach ($called_taxs as $tax_key => $n) {
        unset($taxs[$tax_key]);
    }


    $called_taxs = array_flip($called_taxs);
    $allTax = array_flip($allTax);
    $rest_taxs = array_flip($taxs);

    $args['posts_per_page'] = -1;

    $posts = get_posts($args);
    $fTaxbyQuery = [];
    foreach ($posts as $m_post) {
        $post_id = $m_post->ID;
        if (empty($allTax)) continue;
        foreach ($allTax as $taxonomy) { //$allTax
            $th_term = get_the_terms($post_id, $taxonomy);
            if (!empty($th_term)) {
                foreach ($th_term as $each_th_term) {
                    //$slug = $each_th_term->slug;
                    $term_id = $each_th_term->term_id;
                    $name = $each_th_term->name;
                    $fTaxbyQuery[$taxonomy][$term_id] = $name;
                }
            } else {
                $fTaxbyQuery[$taxonomy] = [];
            }

        }

    }
    wp_reset_query();
    wp_reset_postdata();

    if (empty($fTaxbyQuery)) {
        echo "";
    } else {
        echo wp_json_encode($fTaxbyQuery);
    }

    die();
}

add_action('wp_ajax_wpt_pro_cascade_filter', 'wpt_cascade_filter');
add_action('wp_ajax_nopriv_wpt_pro_cascade_filter', 'wpt_cascade_filter');

function wpt_cascade_localize_data_callback($WPT_DATA)
{
    $WPT_DATA['select2'] = 'disable';
    return $WPT_DATA;
}

add_filter('wpto_localize_data','wpt_cascade_localize_data_callback');


function wpt_cascade_remove_placeholder($WPT_DATA)
{
    $WPT_DATA['search_select_placeholder'] = "";
    return $WPT_DATA;
}

add_filter('wpto_localize_data', 'wpt_cascade_remove_placeholder');

function wpt_cascade_is_multiple_selectable($bool)
{
    $bool = false;
    return $bool;
}

add_filter('wpto_is_multiple_selectable','wpt_cascade_is_multiple_selectable');
